BackroomsManager = BackroomsManager or class()

BackroomsManager.size = 13
BackroomsManager.tile_size = 1200
BackroomsManager.tile = {
	-- Floor
	{ Idstring("units/payday2/architecture/off_int_fbi/off_int_fbi_floor_carpet_4x4m"), Vector3( 200, -600, 0), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/off_int_fbi/off_int_fbi_floor_carpet_4x4m"), Vector3(-200, -600, 0), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/off_int_fbi/off_int_fbi_floor_carpet_4x4m"), Vector3(-600, -600, 0), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/off_int_fbi/off_int_fbi_floor_carpet_4x4m"), Vector3( 200, -200, 0), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/off_int_fbi/off_int_fbi_floor_carpet_4x4m"), Vector3(-200, -200, 0), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/off_int_fbi/off_int_fbi_floor_carpet_4x4m"), Vector3(-600, -200, 0), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/off_int_fbi/off_int_fbi_floor_carpet_4x4m"), Vector3( 200,  200, 0), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/off_int_fbi/off_int_fbi_floor_carpet_4x4m"), Vector3(-200,  200, 0), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/off_int_fbi/off_int_fbi_floor_carpet_4x4m"), Vector3(-600,  200, 0), Rotation(0, 0, 0) },

	-- Ceiling
	{ Idstring("units/payday2/architecture/hcm/hcm_int_ceiling_4x4m_a_cork"), Vector3( 200, -600, 300), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/hcm/hcm_int_ceiling_4x4m_a_cork"), Vector3(-200, -600, 300), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/hcm/hcm_int_ceiling_4x4m_a_cork"), Vector3(-600, -600, 300), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/hcm/hcm_int_ceiling_4x4m_a_cork"), Vector3( 200, -200, 300), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/hcm/hcm_int_ceiling_4x4m_a_cork"), Vector3(-200, -200, 300), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/hcm/hcm_int_ceiling_4x4m_a_cork"), Vector3(-600, -200, 300), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/hcm/hcm_int_ceiling_4x4m_a_cork"), Vector3( 200,  200, 300), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/hcm/hcm_int_ceiling_4x4m_a_cork"), Vector3(-200,  200, 300), Rotation(0, 0, 0) },
	{ Idstring("units/payday2/architecture/hcm/hcm_int_ceiling_4x4m_a_cork"), Vector3(-600,  200, 300), Rotation(0, 0, 0) },

	-- Walls
	{ Idstring("units/payday2/architecture/com_int_gallery/com_int_gallery_wall_4m_a_white"), Vector3(-200  , -612.5, 0), Rotation(  90, 0, 0) },
	{ Idstring("units/payday2/architecture/com_int_gallery/com_int_gallery_wall_4m_a_white"), Vector3( 600  , -612.5, 0), Rotation(  90, 0, 0) },
	{ Idstring("units/payday2/architecture/com_int_gallery/com_int_gallery_wall_4m_a_white"), Vector3(-587.5, -200  , 0), Rotation(-180, 0, 0) },
	{ Idstring("units/payday2/architecture/com_int_gallery/com_int_gallery_wall_4m_a_white"), Vector3(-587.5,  600  , 0), Rotation(-180, 0, 0) },

	-- Lights
	{ Idstring("units/pd2_dlc_tag/props/tag_prop_light_ceiling_tiled/tag_prop_light_ceiling_tiled"), Vector3(-125, -400, 300), Rotation(0, 0, 0) },
	{ Idstring("units/pd2_dlc_tag/props/tag_prop_light_ceiling_tiled/tag_prop_light_ceiling_tiled"), Vector3(   0, -400, 300), Rotation(0, 0, 0) },
	{ Idstring("units/pd2_dlc_tag/props/tag_prop_light_ceiling_tiled/tag_prop_light_ceiling_tiled"), Vector3( 125, -400, 300), Rotation(0, 0, 0) },
	{ Idstring("units/pd2_dlc_tag/props/tag_prop_light_ceiling_tiled/tag_prop_light_ceiling_tiled"), Vector3(-125,    0, 300), Rotation(0, 0, 0) },
	{ Idstring("units/pd2_dlc_tag/props/tag_prop_light_ceiling_tiled/tag_prop_light_ceiling_tiled"), Vector3(   0,    0, 300), Rotation(0, 0, 0) },
	{ Idstring("units/pd2_dlc_tag/props/tag_prop_light_ceiling_tiled/tag_prop_light_ceiling_tiled"), Vector3( 125,    0, 300), Rotation(0, 0, 0) },
	{ Idstring("units/pd2_dlc_tag/props/tag_prop_light_ceiling_tiled/tag_prop_light_ceiling_tiled"), Vector3(-125,  400, 300), Rotation(0, 0, 0) },
	{ Idstring("units/pd2_dlc_tag/props/tag_prop_light_ceiling_tiled/tag_prop_light_ceiling_tiled"), Vector3(   0,  400, 300), Rotation(0, 0, 0) },
	{ Idstring("units/pd2_dlc_tag/props/tag_prop_light_ceiling_tiled/tag_prop_light_ceiling_tiled"), Vector3( 125,  400, 300), Rotation(0, 0, 0) }
}

function BackroomsManager:init()
	self._tiles = {}
	self._tile_bools = {}
end

function BackroomsManager:despawn_around(origin_x, origin_y)
	local half_size = math.floor(BackroomsManager.size/2)
	local half_size_sq = half_size * half_size

	for _, tile_data in pairs(self._tiles) do
		local relative_x = tile_data.x - origin_x
		local relative_y = tile_data.y - origin_y
		local distance_sq = (relative_x * relative_x) + (relative_y * relative_y)

		if distance_sq > half_size_sq then
			self:despawn_tile(tile_data.x, tile_data.y)
		end
	end
end

function BackroomsManager:spawn_around(origin_x, origin_y)
	local half_size = math.floor(BackroomsManager.size/2)
	local half_size_sq = half_size * half_size

	for x = 0, (BackroomsManager.size - 1) do
		for y = 0, (BackroomsManager.size - 1) do
			local relative_x = x - half_size
			local relative_y = y - half_size

			local distance_sq = (relative_x * relative_x) + (relative_y * relative_y)
			if distance_sq <= half_size_sq then
				self:spawn_tile(origin_x + relative_x, origin_y + relative_y)
			end
		end
	end
end

function BackroomsManager:despawn_tile(x, y)
	if not self._tile_bools[x] then return end
	if not self._tile_bools[x][y] then return end

	self._tile_bools[x][y] = false
end

function BackroomsManager:spawn_tile(x, y)
	if self._tile_bools[x] and self._tile_bools[x][y] then return end

	self._tile_bools[x] = self._tile_bools[x] or {}
	self._tile_bools[x][y] = true

	local origin = Vector3(
		x * self.tile_size,
		y * self.tile_size,
		0
	)

	local tile_data = {
		x = x,
		y = y,
		units = {}
	}

	for _, unit_data in pairs(self.tile) do
		local unit = World:spawn_unit(unit_data[1], origin + unit_data[2], unit_data[3])
		table.insert(tile_data.units, unit)
	end

	table.insert(self._tiles, tile_data)
end

function BackroomsManager:update()
	local player_unit = managers.player:player_unit()
	if not player_unit then return end

	local player_position = player_unit:position()

	local tile_x = math.round(player_position.x / 1200)
	local tile_y = math.round(player_position.y / 1200)

	self:spawn_around(tile_x, tile_y)
	self:despawn_around(tile_x, tile_y)

	local keep_tiles = {}
	local index_modifier = 0
	for index, tile_data in pairs(self._tiles) do
		if self._tile_bools[tile_data.x] and self._tile_bools[tile_data.x][tile_data.y] then
			keep_tiles[index + index_modifier] = tile_data
		else
			index_modifier = index_modifier - 1

			for _, unit in pairs(tile_data.units) do
				if unit and alive(unit) then
					World:delete_unit(unit)
				end
			end
		end
	end

	self._tiles = keep_tiles
end

Hooks:PostHook(GameSetup, "init_managers", "InitBackroomsManager", function(self, managers)
	managers.backrooms = BackroomsManager:new()
end)

Hooks:PostHook(GameSetup, "update", "UpdateBackroomsManager", function(self, t, dt)
	managers.backrooms:update(t, dt)
end)